//
//Author			: walk.ly  
//Time			: 2009-05-08
//Version		: 1.0.0
//Description	: ͼƽ 	
//

#ifndef __ADJ_TRANSIT_
#define __ADJ_TRANSIT_

#ifdef _VS_WALK
#include "wkClassDefine.h"
#endif

#include "ȷ뻡ת.cpp"


//
bool AdjV(array &vs, array &pwr, double f, int dec, bool byPower)
{
	vs.removeAll();
	int count=pwr.getSize();
	double sumPwr=Sum(pwr);
	for (int i=0; i<count; i++)
		if (byPower)
			vs.add(round5(-f/sumPwr*Double(pwr[i]), dec));
		else
			vs.add(round5(-f/count, dec));

	//*** 
	double fr=Sum(vs)+f;
	AdjRoundError(pwr, vs, fr, dec);

	//֤
	double sumV=Sum(vs);
	if (abs(f+sumV)>0.1/pow(10, dec))
	{
		string msg;
		msg.format("պϲ=%lf, =%lf\nӦֵ!", f, sumV);
		message(msg);
		return false;
	}
	return true;
}

//
bool CalCoords(double bgn, double end, array &dd, array &vs, array &res)
{
	res.removeAll(); res.add(bgn);
	double t;
	for (int i=0; i<dd.getSize(); i++)
	{
		t=Double(res[i])+Double(dd[i])+Double(vs[i]);
		res.add(t);
	}
	if (abs(t-end)>0.000001)
	{
		string msg;
		msg.format("յļֵ=%lf, ֵ֪=%lf\nֵ!", t, end);
		message(msg);
		return false;
	}
	return true;
}


/****************************************************
	ȫֱ
****************************************************/
int cooDec=3;	//ͱ߳СЧλ
int secDec=0;	//ǶȺͷλǵֵЧλ

array ptNames;	//ߵ
array obsA;		//Ƕȹ۲ֵԶΪλ
array obsD;		//۲ֵ

array vsA;		//Ƕȸ
array adjA;		//ǶȣԶΪλ

array adjT;		//λǣԶΪλ

array dsN, dsE;		//dN,dE
array vsN, vsE;	//dN,dE 
array cooN, cooE;	//ߵ

double bgnE, bgnN;	//
double endE, endN;	//յ
double bgnT, endT;	//ʼλǡֹλǣԶΪλ

bool bLeftA=true;	//۲ڵǰ

double f, fa;		//Ƕȱպϲ
double fN, fE, fD;		//պϲ
double k, limK=2000;	//ȫԱպϲĸ


//Ƕȸ
bool AdjustAngle()
{
	int aCount=obsA.getSize();	//۲Ǹ
	if (aCount==0)
		return false;

	//2㷽պϲ ===================================
	f=CalTs(bgnT, obsA, bLeftA)-endT;
	f=round5(f*3600.0, secDec);//ʾպϲ

	//(): 60 * sqrt(n)
	fa=round5(60.0*sqrt(aCount), secDec);
	if (abs(f)>fa)
	{
		string msg;
		msg.format("պϲ=%lf, =%lf\n!", f, fa);
		message(msg);
		return false;
	}

	//3Ƕȸ =======================================
	if (!AdjV(vsA, obsA, f, secDec, false))
		return false;

	//4λ =====================================
	double t=bgnT;
	for (int i=0; i<aCount; i++)
	{
		//Ƕ
		adjA.add(Double(obsA[i])+Double(vsA[i])/3600.0);
		t=CalT(t, adjA[i], bLeftA);
		adjT.add(t);
	}
	//֤յ㷽λ
	if (abs(t-endT)>1e-6)
	{
		string msg;
		msg.format("յļT=%lf, ֪T=%lf\nֵ!", t, endT);
		message(msg);
		return false;
	}
	return true;
}

bool AdjustCoords()
{
	//
	for (int i=0; i<obsD.getSize(); i++)
	{
		double dE, dN;
		ptor(obsD[i], deg_rad(adjT[i]), dN, dE);
		dsN.add(round5(dN, cooDec));
		dsE.add(round5(dE, cooDec));
	}
	//ȫԱպϲ
	double sumN=Sum(dsN);
	double sumE=Sum(dsE);
	double sumD=Sum(obsD);
	fN = round5(sumN - (endN-bgnN), cooDec);
	fE = round5(sumE - (endE-bgnE), cooDec);
	fD = round5(sqrt(fN*fN + fE*fE), cooDec);
	k  = fD>0.001? round5(sumD/fD, 0): 1000000;

	//ȫԱպϲӦ<1/2000
	if (k<=limK)
	{
		string msg;
		msg.format("ȫԱպϲ=1/%.0lf, =1/%.0lf\n!", k, limK);
		message(msg);
		return false;
	}

	//
	if (!AdjV(vsN, obsD, fN, cooDec, true) ||
		!AdjV(vsE, obsD, fE, cooDec, true))
		return false;

	//
	if (!CalCoords(bgnN, endN, dsN, vsN, cooN) ||
		!CalCoords(bgnE, endE, dsE, vsE, cooE))
		return false;

	return true;
}

//ɹ
void Output()
{
	string fileName="c:\\transitRes.txt";
	wkFile fp;
	fp.open(fileName, "wt");

	string msg;
	msg=       "|===========================================================================================================|\n"; fp.puts(msg);
	msg=       "||  ۲ |  v |   |  λ |    |   SN  |   SE  |  vN |  vE |    N  |    E  ||\n"; fp.puts(msg);
	msg=       "|----|---------|----|---------|---------|--------|--------|--------|-----|-----|-----------|-----------|----|\n"; fp.puts(msg);
	msg.format("|    |---------|----|---------|%9.4lf|        |        |        |     |     |-----------|-----------|----|\n",
				deg_dms(bgnT, secDec)); fp.puts(msg);
	int n=ptNames.getSize(), d=cooDec, s=secDec;
	double p=pow(10,d);
	for (int i=0; i<n; i++)
	{
		msg.format("|%4s|%9.4lf|%4.0lf|%9.4lf|---------|--------|--------|--------|-----|-----|%11.*lf|%11.*lf|%4s|\n",
				ptNames[i], deg_dms(obsA[i], s), vsA[i], deg_dms(adjA[i], s), d, cooN[i], d, cooE[i], ptNames[i]);
		fp.puts(msg);
		if (i<n-1)
		{
			msg.format("|----|---------|----|---------|%9.4lf|%8.*lf|%8.*lf|%8.*lf|%+5.0lf|%+5.0lf|-----------|-----------|----|\n",
						deg_dms(adjT[i], s), d,obsD[i], d,dsN[i], d,dsE[i], Double(vsN[i])*p, Double(vsE[i])*p);
		}else
		{
			msg.format("|    |---------|----|---------|%9.4lf|        |        |        |     |     |-----------|-----------|----|\n", deg_dms(endT, s)); fp.puts(msg);
			msg=       "|----|---------|----|---------|---------|--------|--------|--------|-----|-----|-----------|-----------|----|\n"; fp.puts(msg);
			msg.format("|ϼ|%9.4lf|%4.0lf|%9.4lf|%9.4lf|%8.*lf|%8.*lf|%8.*lf|%+5.0lf|%+5.0lf|%11.*lf|%11.*lf|    |\n",
						deg_dms(Sum(obsA), s), Sum(vsA), deg_dms(Sum(adjA), s),
						deg_dms(AdjAngle0_360(endT-bgnT)+(n-2)*180, s), d,Sum(obsD), d,Sum(dsN), d,Sum(dsE),
						Sum(vsN)*pow(10,d), Sum(vsE)*pow(10,d), d, endN-bgnN, d, endE-bgnE);
		}
		fp.puts(msg);
	}
	msg=       "|-----------------------------------------------------------------------------------------------------------|\n"; fp.puts(msg);
	msg.format("| ۲Ϊ%s                                  պϲ fN=%6.*lf ,   fE=%6.*lf ,   fD=%6.*lf    |\n", (bLeftA? "":""), d,fN, d,fE, d,fD); fp.puts(msg);
	msg.format("| պϲ f  =%6.0lf                                          ȫԱպϲk=1/%6.0lf                 |\n", f, k); fp.puts(msg);
	msg.format("| պϲ f=%6.0lf                                          Ապϲk=1/%6.0lf                 |\n", fa, limK); fp.puts(msg);
	msg=       "|                          f<fݣ۲ɹ淶Ҫ󣬿ƽ                                            |\n"; fp.puts(msg);
	msg.format("|%107s|\n", " "); fp.puts(msg);
	msg=       "| עպϲ۲Ƿƽ䣻  պϲ߶γȳȷŷ                                |\n"; fp.puts(msg);
	msg=       "|===========================================================================================================|\n"; fp.puts(msg);

	fp.close();

	//ʹü±ʾ
	wkView view;
	view.shell("notepad "+fileName);
}

//ƽ
void AdjustTransit()
{
	//1λպϲ
	if (!AdjustAngle())
		return ;

	//2պϲ
	if (!AdjustCoords())
		return ;

	//3
	Output();
}

#endif //__ADJ_TRANSIT_
