//
//Author			: walk.djg  
//Time			: 2009-06-18
//Version		: 1.0.0
//Description	: RGB(), GetR(), GetG(), GetB()
//

//rgb.cpp
//purpose:  RGB(r, g, b)
//				GetR(color)
//				GetG(color)
//				GetB(color)
//djg 2010-05-28

#define RGB(r,g,b)          r|g<<8|b<<16

#define GetR(color)			color%0x100
#define GetG(color)			color/0x100%0x100
#define GetB(color)			color/0x10000%0x100